sf_t3d/urls.py
#
#   Copyright 2018 EveryUP Srl
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.conf.urls import url, include
from authosm import views as user_views
from sf_t3d import views

app_name = 'base'
urlpatterns = [
    url(r'^$', views.home, name='home'),
    url(r'^home', views.home, name='home'),
    url(r'^auth/$', user_views.user_login, name='auth_user'),
    url(r'^projects/', include('projecthandler.urls.project', namespace='projects'), name='projects_base'),
    url(r'^sdn/', include('sdnctrlhandler.urls', namespace='sdns'), name='sdns_base'),
    url(r'^vims/', include('vimhandler.urls', namespace='vims'), name='vims_base'),
    url(r'^k8scluster/', include('k8sclusterhandler.urls', namespace='k8sc'), name='k8sc_base'),
    url(r'^k8srepo/', include('k8srepohandler.urls', namespace='k8sr'), name='k8sr_base'),
    url(r'^osmrepo/', include('osmrepohandler.urls', namespace='osmr'), name='osmr_base'),
    url(r'^wims/', include('wimhandler.urls', namespace='wims'), name='wims_base'),
    url(r'^packages/', include('packagehandler.urls', namespace='packages'), name='packages_base'),
    url(r'^instances/', include('instancehandler.urls', namespace='instances'), name='instances_base'),
    url(r'^netslices/', include('netslicehandler.urls', namespace='netslices'), name='netslices_base'),
    url(r'^admin/users/', include('userhandler.urls', namespace='users'), name='users_base'),
    url(r'^admin/roles/', include('rolehandler.urls', namespace='roles'), name='roles_base'),
    url(r'^forbidden', views.forbidden, name='forbidden'),

]

userhandler/urls.py
#
#   Copyright 2018 CNIT - Consorzio Nazionale Interuniversitario per le Telecomunicazioni
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.conf.urls import url
from userhandler import views

urlpatterns = [
    url(r'^list$', views.user_list, name='list'),
    url(r'^create$', views.create, name='create'),
    url(r'^(?P<user_id>[-\w]+)/info', views.user_info, name='info'),
    url(r'^(?P<user_id>[-\w]+)$', views.update, name='update'),
    url(r'^(?P<user_id>[-\w]+)/delete$', views.delete, name='delete'),   

]

userhandler/models.py
from __future__ import unicode_literals

from django.db import models

# Create your models here.

userhandler/views.py
#
#   Copyright 2018 EveryUP Srl
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an  BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

from django.shortcuts import render, redirect
from sf_t3d.decorators import login_required
from django.http import HttpResponse
import json
import logging
import authosm.utils as osmutils
from lib.osm.osmclient.clientv2 import Client

logging.basicConfig(level=logging.DEBUG)
log = logging.getLogger(__name__)


@login_required
def user_list(request):
    user = osmutils.get_user(request)
    client = Client()
    result = client.user_list(user.get_token())

    result = {
        'users': result['data'] if result and result['error'] is False else []
    }

    return __response_handler(request, result, 'user_list.html')


@login_required
def create(request):
    user = osmutils.get_user(request)
    client = Client()

    new_user_dict = request.POST.dict()
    keys = ["username", "password", "domain_name"]
    user_data = dict(filter(lambda i: i[0] in keys and len(i[1]) > 0, new_user_dict.items()))
    result = client.user_create(user.get_token(), user_data)
    if result['error']:
        return __response_handler(request, result['data'], url=None,
                                  status=result['data']['status'] if 'status' in result['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


@login_required
def delete(request, user_id=None):
    user = osmutils.get_user(request)
    try:
        client = Client()
        result = client.user_delete(user.get_token(), user_id)
    except Exception as e:
        log.exception(e)
        result = {'error': True, 'data': str(e)}
    if result['error']:
        return __response_handler(request, result['data'], url=None,
                                  status=result['data']['status'] if 'status' in result['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


@login_required
def user_info(request, user_id=None):
    user = osmutils.get_user(request)
    try:
        client = Client()

        info_res = client.get_user_info(user.get_token(), user_id)
    except Exception as e:
        log.exception(e)
        info_res = {'error': True, 'data': str(e)}
    if info_res['error']:
        return __response_handler(request, info_res['data'], url=None,
                                  status=info_res['data']['status'] if 'status' in info_res['data'] else 500)
    else:
        return __response_handler(request, info_res['data'], url=None, status=200)


@login_required
def update(request, user_id=None):
    user = osmutils.get_user(request)
    try:
        client = Client()
        payload = {}

        if request.POST.get('password') and request.POST.get('password') is not '':
            payload["password"] = request.POST.get('password')

        if request.POST.getlist('map_project_name') and request.POST.getlist('map_role_name'):
            project_param_name = request.POST.getlist('map_project_name')
            role_param_ip = request.POST.getlist('map_role_name')
            payload["project_role_mappings"] = []
            for i, project in enumerate(project_param_name):
                payload["project_role_mappings"].append({
                    'project': project,
                    'role': role_param_ip[i],
                })

        update_res = client.user_update(user.get_token(), user_id, payload)
    except Exception as e:
        log.exception(e)
        update_res = {'error': True, 'data': str(e)}
    if update_res['error']:
        return __response_handler(request, update_res['data'], url=None,
                                  status=update_res['data']['status'] if 'status' in update_res['data'] else 500)
    else:
        return __response_handler(request, {}, url=None, status=200)


def __response_handler(request, data_res, url=None, to_redirect=None, *args, **kwargs):
    raw_content_types = request.META.get('HTTP_ACCEPT', '*/*').split(',')
    if 'application/json' in raw_content_types or url is None:
        return HttpResponse(json.dumps(data_res), content_type="application/json", *args, **kwargs)
    elif to_redirect:
        return redirect(url, *args, **kwargs)
    else:
        return render(request, url, data_res)

userhandler/templates/modal/user_create.html
<!--
Copyright 2019 EveryUP srl

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an  BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<div class="modal" id="modal_new_user" xmlns="http://www.w3.org/1999/html">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span></button>
                <h4 class="modal-title">New User</h4>
            </div>
            <form id="formCreateUser" action='{% url "users:create"   %}'
                  class="form-horizontal"
                  method="post" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="modal-body" id="modal_new_user_body">
                    
                    <div class="form-group">
                        <label for="username" class="col-sm-3 control-label">Username *</label>
                        <div class="col-sm-6">
                            <input class="form-control" id="username" name="username"
                                   placeholder="Username" required>
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="password" class="col-sm-3 control-label">Password *</label>
                        <div class="col-sm-6">
                           <input class="form-control" id="password" name="password" type="password"
                                   placeholder="Password" autocomplete="off" required>
                        </div>
                    </div>

                    <div class="form-group">
                            <label for="password" class="col-sm-3 control-label">Conf. Password *</label>
                            <div class="col-sm-6">
                               <input class="form-control" id="password2" name="password2" type="password"
                                       placeholder="Repeat Password" autocomplete="off" required>
                                <div class="row">
                                    <div class="col-sm-12">
                                       <span id="pwmatch" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Passwords Match
                                    </div>
                                </div>
                            </div>
                    </div>

                    <div class="form-group" id="domainNameGroupDiv">
                        <label for="domain_name" class="col-sm-3 control-label">Domain name *</label>
                        <div class="col-sm-6">
                            <select id="domain_name" class="js-example-basic form-control" name="domain_name" required>
                            </select>
                        </div>
                    </div>


                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary"
                            data-loading-text="<i class='fa fa-circle-o-notch fa-spin'></i> Creating..."
                            id="create_new_user">Create
                    </button>

                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

userhandler/templates/modal/user_credentials_edit.html
<!--
Copyright 2019 EveryUP srl

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an  BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<div class="modal" id="modal_edit_user_credentials" xmlns="http://www.w3.org/1999/html">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span></button>
                <h4 class="modal-title">Edit User Credentials</h4>
            </div>
            <form id="formEditUser" action=""
                  class="form-horizontal"
                  method="post" enctype="multipart/form-data">
                {% csrf_token %}
                <input type="hidden"  id="projects_old" name="projects_old" value="asdasd">
                <div class="modal-body" id="modal_edit_user_credentials_body">
                    {% comment %}<div class="form-group">
                        <label for="username_edit" class="col-sm-3 control-label">Username *</label>
                        <div class="col-sm-6">
                            <input class="form-control" id="username_edit" name="username"
                                   placeholder="Username" required>
                        </div>
                    </div>{% endcomment %}
                    <div class="form-group">
                        <label for="password" class="col-sm-3 control-label">New Password</label>
                        <div class="col-sm-6">
                           <input class="form-control" id="edit_password" name="password" type="password"
                                   placeholder="Password">
                        </div>
                    </div>
                    <div class="form-group">
                            <label for="password" class="col-sm-3 control-label">Conf. Password</label>
                            <div class="col-sm-6">
                               <input class="form-control" id="edit_password2" name="password2" type="password"
                                       placeholder="Repeat Password" autocomplete="off" required>
                                <div class="row">
                                    <div class="col-sm-12">
                                       <span id="pwmatch_edit" class="glyphicon glyphicon-remove" style="color:#FF0004;"></span> Passwords Match
                                    </div>
                                </div>
                            </div>
                    </div>
                    {% comment %}
                    <div class="form-group">
                        <label for="projects" class="col-sm-3 control-label">Default project *</label>
                        <div class="col-sm-6">
                            <select required id="default_project_edit" class="js-example-basic form-control" name="default_project">
                            </select>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="projects" class="col-sm-3 control-label">Projects *</label>
                        <div class="col-sm-6">
                            <select required id="projects_edit" class="js-example-basic-multiple form-control" name="projects"
                            multiple="multiple">
                            </select>
                        </div>
                    </div>
                    {% endcomment %}

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary"
                            data-loading-text="<i class='fa fa-circle-o-notch fa-spin'></i> Editing..."
                            id="create_edit_user">Apply
                    </button>

                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

userhandler/templates/modal/user_proj_role_edit.html
<!--
Copyright 2019 EveryUP srl

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an  BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<div class="modal" id="modal_edit_user_role_map" xmlns="http://www.w3.org/1999/html">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span></button>
                <h4 class="modal-title">Edit Project Role Mapping</h4>
            </div>
            <form id="formEditUserRoleMap" action=""
                  class="form-horizontal"
                  method="post" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="modal-body" id="modal_edit_proj_role_map_body">
                       
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default pull-left" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary"
                            data-loading-text="<i class='fa fa-circle-o-notch fa-spin'></i> Editing..."
                            id="edit_user_map">Apply
                    </button>

                </div>
            </form>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>